#Pack to Bag teleport
execute at @e[tag=petbag] as @e[tag=pb_pack] if score @s petbag = @e[sort=nearest,limit=1,tag=petbag] petbag run tp @s ~ ~-0.5 ~

#Bag is to far away from player (teleport to player)
execute as @e[tag=petbag,tag=!pb_sit] at @s at @a[distance=20..] if score @s petbag = @p petbag unless block ~ ~-1 ~ air run tp @s @p

#Player death
execute as @e[tag=petbag,tag=!pb_sit] at @a[scores={pb_respawn=0}] if score @s petbag = @p petbag run tp @s @e[tag=pb_respawn,limit=1]

#Walk activate
scoreboard players add #time petbag 1
execute if score #time petbag matches 4 run function pb:walk
execute if score #time petbag matches 4 run scoreboard players reset #time petbag

#Crafting
execute as @a at @s unless entity @s[scores={petbag=0..}] run tag @e[type=item,distance=..6,nbt={Item:{id:"minecraft:ender_chest",Count:1b}}] add pb_buy
execute at @e[tag=pb_buy,nbt={Item:{id:"minecraft:ender_chest",Count:1b}}] run tag @e[type=item,distance=..1,nbt={Item:{id:"minecraft:iron_block",Count:3b}}] add pb_buy
execute at @e[tag=pb_buy,nbt={Item:{id:"minecraft:iron_block",Count:3b}}] run tag @e[type=item,distance=..1,nbt={Item:{id:"minecraft:leather",Count:5b}}] add pb_buy
execute at @e[tag=pb_buy,nbt={Item:{id:"minecraft:leather",Count:5b}}] run summon item ~ ~ ~ {PickupDelay:8,Motion:[0.0,0.4,0.0],Item:{id:"minecraft:bat_spawn_egg",Count:1b,tag:{display:{Name:"{\"text\":\"PetBag\",\"color\":\"dark_green\",\"bold\":true,\"italic\":false}"},EntityTag:{NoGravity:1b,Silent:1b,NoAI:1b,Tags:["pb_spawn"]}}}}
execute at @e[tag=pb_buy,nbt={Item:{id:"minecraft:leather",Count:5b}}] run playsound minecraft:block.anvil.use master @a[distance=..5]
execute at @e[tag=pb_buy,nbt={Item:{id:"minecraft:leather",Count:5b}}] run kill @e[tag=pb_buy]

#Spawn
execute at @e[tag=pb_spawn] run summon armor_stand ~ ~ ~ {Invulnerable:1b,Small:1b,Invisible:1b,NoBasePlate:1b,Tags:["petbag"],DisabledSlots:4144959}
execute at @e[tag=pb_spawn] run summon minecraft:chest_minecart ~ ~ ~ {Invulnerable:1b,CustomName:"{\"text\":\"PetBag\",\"color\":\"dark_green\",\"bold\":true,\"italic\":false}",CustomDisplayTile:true,DisplayState:{Name:"minecraft:barrel"},DisplayOffset:4,NoGravity:1b,Tags:["pb_pack"]}
execute at @e[tag=pb_spawn] run scoreboard players add #count petbag 1
execute at @e[tag=pb_spawn] run scoreboard players operation @e[tag=petbag,sort=nearest,limit=1] petbag = #count petbag
execute at @e[tag=pb_spawn] run scoreboard players operation @e[tag=pb_pack,sort=nearest,limit=1] petbag = @e[tag=petbag,sort=nearest,limit=1] petbag
execute at @e[tag=pb_spawn] as @p unless entity @s[scores={petbag=0..}] run scoreboard players operation @s petbag = @e[tag=petbag,sort=nearest,limit=1] petbag
execute at @e[tag=pb_spawn] run kill @e[tag=pb_spawn]

#Start Message
execute unless score #msg petbag matches 1 run tellraw @a ["",{"text":"Please go to the spawn of your world and press this button, if you don't want lose your PetBag if you die. (You must be Admin) ","color":"dark_red","clickEvent":{"action":"run_command","value":"/summon armor_stand ~ ~1 ~ {NoGravity:1b,Small:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,Tags:[\"pb_respawn\"]}"}},{"text":"[]","color":"dark_red","clickEvent":{"action":"run_command","value":"/summon armor_stand ~ ~1 ~ {NoGravity:1b,Small:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,Tags:[\"pb_respawn\"]}"},"hoverEvent":{"action":"show_text","value":"Click here"}}]
execute unless score #msg petbag matches 1 run scoreboard players set #msg petbag 1

#Sneak to stop
execute at @a[scores={pb_sneak=1..},tag=!pb_sit_detect] as @e[tag=petbag,distance=..1,tag=!pb_sit] if score @p petbag = @s petbag run tag @s add pb_sit_load
execute at @a[scores={pb_sneak=1..},tag=!pb_sit_detect] as @e[tag=petbag,distance=..1,tag=pb_sit] if score @p petbag = @s petbag run tag @s remove pb_sit
execute at @a[scores={pb_sneak=1..},tag=!pb_sit_detect] as @e[tag=petbag,distance=..1] if score @p petbag = @s petbag run tag @p add pb_sit_detect
execute at @a as @e[tag=pb_sit_load] if score @p petbag = @s petbag run tellraw @p {"text":"PetBag is sitting!","color":"aqua"}
execute as @e[tag=pb_sit_load] run tag @s add pb_sit
execute as @e[tag=pb_sit_load] run tag @s remove pb_sit_load
execute at @a[tag=pb_sit_detect] unless entity @e[tag=petbag,distance=..1.3] run tag @p remove pb_sit_detect
execute as @a[scores={pb_sneak=1..}] run scoreboard players reset @s pb_sneak
execute at @e[tag=petbag,tag=pb_sit] run particle minecraft:dust 255 0 0 1 ~ ~0.5 ~ 0.1 0.1 0.1 0 1 force @a

#Hopper block
function pb:hopper